' Homerseklet mero, termosztat program PICPLC8 / PICPLC16 mikrogepre, DS1820 szenzorral

DQ	Var	PORTA.0			' DS1820 adatlaba, a DQ, a PORTA.0 labon
	ADCON1 = 7			' A PORTA es a PORTE most digitalis portkent mukodjon
					' Megadjuk az LCD vezerlesi parametereit :
	DEFINE LCD_DREG 	PORTD	' Az LCD adatbitek a D porton,
	DEFINE LCD_DBIT 	0	' es az els bit az RD0.
	DEFINE LCD_RSREG 	PORTD	' A register select bit a D porton,
	DEFINE LCD_RSBIT 	4	' az RD4 port.
	DEFINE LCD_EREG 	PORTD	' Az enable bit a D porton,
	DEFINE LCD_EBIT 	5	' az RD5 portra van kiosztva.
	DEFINE LCD_BITS 	4	' A 4 bites zemmodot valasztjuk,
	DEFINE LCD_LINES 	2	' es 2 soros az LCD
	
hofok 		Var	Word		' A "hofok" valtozonak egy 2 bjtos helyet foglalok
meres_ok 	Var 	Byte		' Allapotjelzo a mereshez
	
       					' Felszolitom a DS1820-at, hogy  
main: 	OWOut DQ, 1, [$CC, $44]		' csinaljon egy homerseklet merest!
					
meres: 	OWIn DQ, 4, [meres_ok]		' Varom hogy vegezzen... Amig a meres_ok = 0 , nincs kesz!
	If meres_ok = 0 Then meres 	' Csak ha a meres_ok mar nem nullat ad, mehetunk tovabb.
					' Most mar beolvashatom a hofokot.
	OWOut DQ, 1, [$CC, $BE]		' Felszolitom a 1820-at, hogy kuldje az adatokat!
	
       	OWIn DQ, 0, [hofok.LOWBYTE, hofok.HIGHBYTE]	' Az adatokat "hofok" valtozoba olvasom.
	
					' At kell szamolnom az eredmenyt Celsius fokra:
					' Egy bit, 0.5 foknak felel meg. (Pl. ha 51-et olvasok ki, az 25.5 C)
	hofok = hofok * 5		' Ha szorzom 5-el a hofok erteket, akkor homerseklet ertek 10-szereset kapom 
					' Pl. ha 51 volt a hofok valtozoban, akkor a muvelet utan 255 lesz.
	Lcdout $fe, 1, "Szenzor: ", DEC (hofok / 10), ".", DEC1 hofok, " C"	' Kirakom az eredmenyt az LCD-re

        Pause 1000                      ' Egy masodperc szunet...

					' Es akkor a relek vezerlese, a homerseklet szerint:
					' A releket leptet regisztereken keresztl vezereljk
	lepes var byte			' A "lepes" lesz leptetes szamlaloja
	
	STROBE var PORTB.5		' A 74HC4094 kimeneti beiro jele a PORTB.5,
	CLK var PORTB.7			' az orajele a PORTB.7,
	DAT var PORTB.6 		' az adat bemenete a PORTB.6-ra van kiosztva.

	IF hofok >= 320 Then HIGH DAT 	' Ha 32.0 foknal melegebb van, relek be! 
	IF hofok <= 300 Then LOW DAT 	' Ha 30.0 fok ala megy a homerseklet, relek ki!

	FOR lepes = 1 TO 16 		' Az adatok beleptetese a sorba kotott 4094-ekbe
	HIGH CLK			' az orajelbemenet magasra kapcsolva 
	Pause 1				' egy kicsit magasan tartjuk
	LOW CLK 			' majd alacsony szintre kapcsolva egy oraimpulzust csinaltunk.
	NEXT lepes			' Vissza a ciklusba, amig a 2x8=16 bit nincs beleptetve 

	HIGH STROBE			' Hoga a beleptetett adatokat a kimenetre kapcsoljuk, 
	Pause 1				' a "Strobe"-ra egy beiro jelet kell adnunk.
	LOW STROBE 			' A 4094 kimeneten megjelennek a beleptetett adatok.

	Goto main			' Do it forever...